/**************************************************************************
The contents of this file are subject to the POSSENET Public License 
Version 1.0 (the "License"); you may not use this file except in compliance 
with the License. You may obtain a copy of the License at 
http://www.possenet.org/license.html.

Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
for the specific language governing rights and limitations under the 
License. 

The Original Code is Progress IDE, released December 1, 2000. 

The Initial Developer of the Original Code is Progress Software 
Corporation. Portions created by are Copyright (c) 2000. All Rights 
Reserved. 
**************************************************************************/

/* Flag set by the output-content-type() function to the Content-Type header
   value that was output.  If this is blank, then the output-content-type()
   function has not been run yet which should imply no other output has
   been sent either. */
DEFINE {1} {2} SHARED VARIABLE output-content-type AS char NO-UNDO.

/* Newline characters to use for the output-http-header() function.
   Some web servers do not allow the CR, LF combination but only support
   an LF character. */
DEFINE {1} {2} SHARED VARIABLE http-newline AS char NO-UNDO
    INITIAL "~r~n".

/* Offset from Coordinated Universal Time (UTC) or GMT time in seconds.
   This value is updated with each request.  A positive number is west of
   UTC.  This is used to calculate UTC time when setting Cookie expiration
   dates in the set-cookie() function. */
DEFINE {1} {2} SHARED VARIABLE utc-offset AS INTEGER NO-UNDO INITIAL -1.

/* Unsafe characters that must be encoded in URL's.  See RFC 1738 Sect 2.2. */
DEFINE {1} {2} SHARED VARIABLE url_unsafe   AS CHARACTER NO-UNDO 
    INITIAL " <>~"#%{}|~\^~~[]`":U.

/* Reserved characters that normally are not encoded in URL's */
DEFINE {1} {2} SHARED VARIABLE url_reserved AS CHARACTER NO-UNDO 
    INITIAL "~;/?:@=&":U.

/* CGI 1.1 Vars */
def {1} {2} shared var auth_type            as char no-undo.
def {1} {2} shared var content_length       as int  no-undo.
def {1} {2} shared var content_type         as char no-undo.
def {1} {2} shared var gateway_interface    as char no-undo.
def {1} {2} shared var gmt_offset           as int  no-undo.
def {1} {2} shared var http_accept          as char no-undo.
def {1} {2} shared var http_accept_language as char no-undo.
def {1} {2} shared var http_cookie          as char no-undo.
def {1} {2} shared var http_referer         as char no-undo.
def {1} {2} shared var http_user_agent      as char no-undo.
def {1} {2} shared var https                as char no-undo.
def {1} {2} shared var path_info            as char no-undo.
def {1} {2} shared var path_translated      as char no-undo.
def {1} {2} shared var query_string         as char no-undo.
def {1} {2} shared var remote_addr          as char no-undo.
def {1} {2} shared var remote_host          as char no-undo.
def {1} {2} shared var remote_ident         as char no-undo.
def {1} {2} shared var remote_user          as char no-undo.
def {1} {2} shared var request_method       as char no-undo.
def {1} {2} shared var script_name          as char no-undo.
def {1} {2} shared var server_name          as char no-undo.
def {1} {2} shared var server_port          as char no-undo.
def {1} {2} shared var server_protocol      as char no-undo.
def {1} {2} shared var server_software      as char no-undo.

def {1} {2} shared var wseu                 as char no-undo.

def {1} {2} shared var rex_pid              as char no-undo.

def {1} shared workfile cgi no-undo
  field key as char
  field val as char
  field type as char.

def {1} shared stream stx.

&global-define out put stream stx unformatted
&global-define webstream stream stx
