{iris_def.i new global}

def var vc_line as char no-undo.
def var vi as int no-undo.
def var vc as char no-undo.
def var vc_pgm as char no-undo.
def var vc_path as char no-undo.
def var vc_rad_port as char no-undo.
def var vc_rex_port as char no-undo.
def var vi_hits as int no-undo.
def var vl_ok as logi no-undo.

vc_rad_port = entry(1,session:parameter,":").
vc_rex_port = entry(2,session:parameter,":").

repeat:

  /* redirect a stream through iris_rex.pl, 
     it will provide TCP/IP comm for us */
  input-output stream stx through
    value("perl iris_rex.pl " + vc_rad_port + " " + vc_rex_port)
    binary no-echo no-map unbuffered no-convert.

  /* reset things for a fresh request */
  for each cgi exclusive:
    delete cgi.
  end.

  output-content-type = ?.
  
  /* read what iris_rex.pl has for us, special messages will
     cause us to quit, regular messages will be name=value pairs */
  vl_ok = false.
  repeat:
    vc_line = "".
    import stream stx unformatted vc_line.
    if vc_line = "norad" or 
      vc_line = "noserver" or
      vc_line = "*quit*quit*quit*" then do:
      input-output close.
      quit.
    end.
    /* when we get a null line, we are done receiving */
    if vc_line = "" then do:
      vl_ok = true.
      leave.
    end.
    /* if it's not name=value, then we don't want it */
    vi = index(vc_line,"=").
    if vi = 0 then next.
    /* record the name=value pairs in the cgi temp-table,
       for now assume all are type "field" */
    create cgi.
    assign
      cgi.key = substring(vc_line,1,(vi - 1))
      cgi.val = substring(vc_line,(vi + 1))
      cgi.type = "field".
  end.

  /* if vl_ok was not set to true then iris_rex.pl 
     crashed for some reason and we should quit */
  if not vl_ok then quit.

  /* increment the hit counter */
  vi_hits  = vi_hits + 1.

  /* assign the special global cgi vars and set their type to "cgi" */
  find first cgi where cgi.key = "auth_type" exclusive no-error.
  if avail cgi then assign
    AUTH_TYPE = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "content_length" exclusive no-error.
  if avail cgi then do:
    assign
      CONTENT_LENGTH = integer(cgi.val) no-error.
    assign
      cgi.type = "cgi".
  end.

  find first cgi where cgi.key = "content_type" exclusive no-error.
  if avail cgi then assign
    CONTENT_TYPE = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "gateway_interface" exclusive no-error.
  if avail cgi then assign
    GATEWAY_INTERFACE = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "gmt_offset" exclusive no-error.
  if avail cgi then do:
    assign
      GMT_OFFSET = integer(cgi.val) no-error.
    assign
      cgi.type = "cgi".
  end.

  find first cgi where cgi.key = "http_accept" exclusive no-error.
  if avail cgi then assign
    HTTP_ACCEPT = cgi.val
    cgi.type = "cgi".
   
  find first cgi where cgi.key = "http_accept_language" exclusive no-error.
  if avail cgi then assign
    HTTP_ACCEPT_LANGUAGE = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "http_cookie" exclusive no-error.
  if avail cgi then assign
    HTTP_COOKIE = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "http_referer" exclusive no-error.
  if avail cgi then assign
    HTTP_REFERER = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "http_user_agent" exclusive no-error.
  if avail cgi then assign
    HTTP_USER_AGENT = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "https" exclusive no-error.
  if avail cgi then assign
    HTTPS = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "path_info" exclusive no-error.
  if avail cgi then assign
    PATH_INFO = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "path_translated" exclusive no-error.
  if avail cgi then assign
    PATH_TRANSLATED = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "query_string" exclusive no-error.
  if avail cgi then assign
    QUERY_STRING = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "remote_addr" exclusive no-error.
  if avail cgi then assign
    REMOTE_ADDR = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "remote_host" exclusive no-error.
  if avail cgi then assign
    REMOTE_HOST = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "remote_ident" exclusive no-error.
  if avail cgi then assign
    REMOTE_IDENT = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "remote_user" exclusive no-error.
  if avail cgi then assign
    REMOTE_USER = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "request_method" exclusive no-error.
  if avail cgi then assign
    REQUEST_METHOD = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "script_name" exclusive no-error.
  if avail cgi then assign
    SCRIPT_NAME = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "server_name" exclusive no-error.
  if avail cgi then assign
    SERVER_NAME = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "server_port" exclusive no-error.
  if avail cgi then assign
    SERVER_PORT = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "server_protocol" exclusive no-error.
  if avail cgi then assign
    SERVER_PROTOCOL = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "server_software" exclusive no-error.
  if avail cgi then assign
    SERVER_SOFTWARE = cgi.val
    cgi.type = "cgi".

  find first cgi where cgi.key = "rex_pid" exclusive no-error.
  if avail cgi then assign
    REX_PID = cgi.val
    cgi.type = "cgi".

  /* create a special global var made up of other items */
  create cgi.
  assign 
    cgi.key = "wseu"
    cgi.val = REMOTE_ADDR + ":" + vc_rad_port + ":" + 
              REX_PID + ":" + trim(string(vi_hits,">>>>>>>>9"))
    cgi.type = "cgi"
    WSEU = cgi.val.
  
  /* parse QUERY_STRING and add to the cgi table */
  vc_line = QUERY_STRING.
  do vi = 1 to num-entries(vc_line,"&"):
    /* don't overwrite existing fields, form posts take precedence */
    if can-find (first cgi where cgi.key = entry(1,entry(vi,vc_line,"&"),"=")
                 and cgi.type = "field") then next.
    create cgi.
    assign
      cgi.key = entry(1,entry(vi,vc_line,"&"),"=")
      cgi.val = (if num-entries(entry(vi,vc_line,"&"),"=") > 1 then
                 entry(2,entry(vi,vc_line,"&"),"=") else "")
      cgi.type = "field".
  end.
  
  /* parse HTTP_COOKIE and add to the cgi table, type = "cookie" */
  vc_line = HTTP_COOKIE.
  do vi = 1 to num-entries(vc_line,";"):
    create cgi.
    assign
      cgi.key = trim(entry(1,entry(vi,vc_line,";"),"="))
      cgi.val = (if num-entries(entry(vi,vc_line,";"),"=") > 1 then
                 trim(entry(2,entry(vi,vc_line,";"),"=")) else "")
      cgi.type = "cookie".
  end.

  /* parse PATH_INFO for the name of the program we are to run,
     some web servers like IIS include the whole path, some like
     Apache only include the stuff after iris.pl, if everything 
     is included we need to strip it off, also remove leading "/" */
  vc_pgm = PATH_INFO.
  if index(PATH_INFO,SCRIPT_NAME) > 0 then
    vc_pgm = replace(vc_pgm,SCRIPT_NAME,"").
  if length(vc_pgm) > 1 then
    vc_pgm = substring(vc_pgm,2).  
  vc = vc_pgm.  
    
  /* strip off any extension given, then search for ".r",
     ".p" and ".w" extensions until we find one to run */  
  if r-index(vc_pgm,".") > 0 then
    vc_pgm = substring(vc_pgm,1,r-index(vc_pgm,".") - 1).
    
  if search(vc_pgm + ".r") <> ? then
    vc_pgm = vc_pgm + ".r".
  else if search(vc_pgm + ".p") <> ? then
    vc_pgm = vc_pgm + ".p".
  else if search(vc_pgm + ".w") <> ? then
    vc_pgm = vc_pgm + ".w".
    
  /* if we didn't find a suitable file to run,
     return an error */  
  if index(vc_pgm,".") = 0 then do:
    {&out}
      'Content-Type: text/html' skip(1)
      '<html><head></head><body bgcolor="#FFFFFF">' skip
      "<h2>ERROR: " vc " could not be found.</h2><br>" skip
      '</body></html>' skip.
  end.
  /* othewise run the program */
  else do:
    run value(vc_pgm) no-error.
    /* trap any errors and report them */
    if error-status:error then do:
      {&out}
        'Content-Type: text/html' skip(1)
        '<html><head></head><body bgcolor="#FFFFFF">' skip
        '<h2>ERROR: Errors running ' vc_pgm '.</br></br>' skip.        
      do vi = 1 to error-status:num-messages:
        {&out} error-status:get-message(vi) '</br>' skip.
      end.
      {&out} '</body></html>' skip.
    end.
  end.
  
  /* close the pipes to signal iris_rex.pl that we are done
     and start over */
  input-output stream stx close.

end.
