#! /perl/bin/perl.exe

use IO::Socket;
use IO::Select;

# Read configuration data, strip out comment lines and store
# the name value pairs in a hash named params
unless(open(TMP, "< iris.cfg")) { die "Could not read configuration file."; }
@lines = <TMP>;
unless(close(TMP)) { die "Could not close configuration file."; }
@lines = grep !/^#/, @lines;
for (@lines) {
  chomp(($key,$value) = split('=',$_,2));
  $params{$key} = $value;
}

$RadHost = $params{'RadHost'};
$RadPort = $params{'RadPort'};

if ($ENV{'SERVER_SOFTWARE'} gt "") {
  print "Content-Type: text/html\n\n";
  print "<html><head></head><body>\n";
  print "<h2>Iris RAD Status</h2>\n";
  print "<b>Host: </b>$RadHost &nbsp; <b>Port: </b>$RadPort<br>&nbsp;<br>\n";
} else {
  print "Iris RAD Status\n";
  print "Host: $RadHost  Port: $RadPort\n\n";
}

unless($sock = IO::Socket::INET->new("$RadHost:$RadPort")) {
  print "Couldn't connect to Iris_Rad on $RadHost:$RadPort.\n";
  exit;
}

select($sock);
$| = 1;
select(STDOUT);
$| = 1;

print $sock "Cmd: Stat \n";

$sel = IO::Select->new();
$sel->add($sock);

while (1) {
  if (@ready = $sel->can_read(10)) {
    $temp = readline($sock);
    last if ! $temp;
    print "$temp";
    if ($ENV{'SERVER_SOFTWARE'} gt "") {
      print "<br>";
     }
  } else {
    print "timeout\n";
    exit;
  }
}

$sock->close;

if ($ENV{'SERVER_SOFTWARE'} gt "") {
  print "</body></html>\n";
}
