#! /perl/bin/perl.exe

use IO::Socket;

# Read configuration data, strip out comment lines and store
# the name value pairs in a hash named params
unless(open(TMP, "< iris.cfg")) { die "Could not read configuration file."; }
@lines = <TMP>;
unless(close(TMP)) { die "Could not close configuration file."; }
@lines = grep !/^#/, @lines;
for (@lines) {
  chomp(($key,$value) = split('=',$_,2));
  $params{$key} = $value;
}

$RadHost = $params{'RadHost'};
$RadPort = $params{'RadPort'};

if ($ENV{'SERVER_SOFTWARE'} gt "") {
  print "Content-Type: text/html\n\n";
  print "<html><head></head><body>\n";
  print "<h2>Iris RAD Stop</h2>\n";
  print "<b>Host: </b>$RadHost &nbsp; <b>Port: </b>$RadPort<br>&nbsp;<br>\n";
} else {
  print "Iris RAD Stop\n";
  print "Host: $RadHost  Port: $RadPort\n\n";
}

unless($sock = IO::Socket::INET->new("$RadHost:$RadPort")) {
  print "Couldn't connect to Iris_Rad on $RadHost:$RadPort.\n";
  exit;
}

select($sock);
$| = 1;
select(STDOUT);

print $sock "Cmd: Stop \n";

$sock->close;

print "Command Sent\n";

if ($ENV{'SERVER_SOFTWARE'} gt "") {
  print "</body></html>\n";
}

